using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Android
{
    public class Android
    {
        public static void Main()
        {

         ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Headcrab",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "not currently functional. hope i can actually make it work.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("headcrabthumbnail.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("headcrabfront.png");
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;
                            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");
                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;


                        Instance.FixColliders();

                        Instance.FixColliders();
                        var childObject = new GameObject("Backlegs");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("headcrabbacklegs.png");
                        childSprite.sortingLayerName = "Bottom";
                    }
                }
            );


         ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Fast Headcrab",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "kill",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("fastheadcrabthumbnail.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fastheadcrabfront.png");
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;
                            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");
                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;

                        Instance.FixColliders();
                        var childObject = new GameObject("Backlegs");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("fastheadcrabback.png");
                        childSprite.sortingLayerName = "Bottom";


                    }
                }
            );


         ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Headcrab Canister (Headcrab)",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "the reason why Thimbletuna is a contributor. thanks man for the idea :)",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HCCanisterHCNORMAL.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HCCannisterclosed.png");
        		Sprite on = ModAPI.LoadSprite("HCCanisteropened.png");
        		Instance.AddComponent<UseEventTrigger>().Action = () =>
        		{
            		Instance.GetComponent<SpriteRenderer>().sprite = on;
        		};
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Headcrab");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 0.4f;
                            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 12f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 12f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 12f;

                        Instance.FixColliders();

                    }
                }
            );

         ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Missile Launcher"),
                    NameOverride = "canister spawner",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "coock",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite("headcrabthumbnail.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Headcrab Canister (Headcrab)");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 900f;



                    }
                }
            );


         ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Headcrab Canister (Fast Headcrab)",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "do fast headcrabs jump out of canisters? i mean, like they must have to appear in ravenholm. but i've seen people believe that the fast headcrab was an evolution unique to earth, so maybe they evolved in ravenholm? but then again, what about the poison headcrab? did they evolve in ravenholm? personally, i think they were combine manufactured, but that could mean the fast headcrab zombie is too... but if they were engineered then that would make the previous idea false. but if they did evolve, why not the poison headcrabs? speaking of evolution, what did the headcrab evolve with that was so close to humans that it would work on them? was it just lucky or were they using another species like the vortiguants? xen is a collection of random places across the universe, so possibly the headcrab didn't evolve with the vortiguants, but then with what? i think this is long enough to make the joke funny, and i hope you cant see this. if you can see this then my lord, this just ruined any sense of unintentional humour there may have been.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HCCanisterHCFAST.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HCCannisterclosed.png");
        		Sprite on = ModAPI.LoadSprite("HCCanisteropened.png");
        		Instance.AddComponent<UseEventTrigger>().Action = () =>
        		{
            		Instance.GetComponent<SpriteRenderer>().sprite = on;
        		};
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Fast Headcrab");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 0.4f;
                            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 12f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 12f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 12f;

                        Instance.FixColliders();

                    }
                }
            );


        }
    }
}